Package org.apache.sis.coverage

# Interface BandedCoverage.Evaluator

All Superinterfaces:
  `Function<DirectPosition,double[]>`

All Known Implementing Classes:
  `GridEvaluator`

Enclosing class:
  BandedCoverage

public static interface BandedCoverage.Evaluator extends Function<DirectPosition,double[]>
Computes or interpolates values of sample dimensions at given positions. Values are computed by calls to `apply(DirectPosition)` and are returned as `double[]`.

## Multi-threading

Evaluators are not thread-safe. An instance of `Evaluator` should be created for each thread that need to compute sample values.

Since:
  1.1
See Also:
  - `BandedCoverage​.evaluator()`

Defined in the `sis-feature` module

- ## Method Summary

  Modifier and Type
  Method
  Description
  `double[]`
  `apply(DirectPosition point)`
  Returns a sequence of double values for a given point in the coverage.
  `BandedCoverage`
  `getCoverage()`
  Returns the coverage from which this evaluator is computing sample values.
  `boolean`
  `isNullIfOutside()`
  Returns whether to return `null` instead of throwing an exception if a point is outside coverage bounds.
  `void`
  `setNullIfOutside(boolean flag)`
  Sets whether to return `null` instead of throwing an exception if a point is outside coverage bounds.

  ### Methods inherited from interface Function

  `andThen, compose`

- ## Method Details

  - ### getCoverage

    BandedCoverage getCoverage()
    Returns the coverage from which this evaluator is computing sample values.
    Returns:
      the source of sample values for this evaluator.

  - ### isNullIfOutside

    boolean isNullIfOutside()
    Returns whether to return `null` instead of throwing an exception if a point is outside coverage bounds. The default value is `false`, which means that the default `apply(DirectPosition)` behavior is to throw `PointOutsideCoverageException` for points outside bounds.
    Returns:
      whether `apply(DirectPosition)` return `null` for points outside coverage bounds.

  - ### setNullIfOutside

    void setNullIfOutside(boolean flag)
    Sets whether to return `null` instead of throwing an exception if a point is outside coverage bounds. The default value is `false`. Setting this flag to `true` may improve performances if the caller expects that many points will be outside coverage bounds, since it reduces the amount of exceptions to be thrown.
    Parameters:
      `flag` - whether `apply(DirectPosition)` should use `null` return value instead of `PointOutsideCoverageException` for signaling that a point is outside coverage bounds.

  - ### apply

    double[] apply(DirectPosition point) throws CannotEvaluateException
    Returns a sequence of double values for a given point in the coverage. The CRS of the given point may be any coordinate reference system; coordinate conversions will be applied as needed. If the CRS of the point is undefined, then it is assumed to be the coverage CRS. The returned sequence includes a value for each sample dimension.
    Specified by:
      `apply` in interface `Function<DirectPosition,double[]>`
    Parameters:
      `point` - the coordinate point where to evaluate.
    Returns:
      the sample values at the specified point, or `null` if the point is outside the coverage. For performance reason, this method may return the same array on every method call by overwriting previous values. Callers should not assume that the array content stay valid for a long time.
    Throws:
      `PointOutsideCoverageException` - if the evaluation failed because the input point has invalid coordinates and the `isNullIfOutside()` flag is `false`.
      `CannotEvaluateException` - if the values can not be computed at the specified coordinates for another reason. For example this exception may be thrown if the coverage data type can not be converted to `double` by an identity or widening conversion.